#include "stdafx.h"
#include "lmopros2.h"

class Lmopros2lib {
public:
	FARPROC c_CreateOpros;
	FARPROC c_DestroyOpros;
	FARPROC c_IsServerConnected;
	FARPROC c_RegisterChannel;
	FARPROC c_RegisterValueByID;
	FARPROC c_RegisterAttribute;
	FARPROC c_ReceiveControl;

#define DIE( s ) { MessageBoxA( NULL, s, "", 0 ); ExitProcess( 1 ); }
#define LOAD( func ) \
	if( ( c_##func = GetProcAddress( module, "_c_" #func ) ) == NULL ) \
		DIE( "    " #func "  lmopros2.dll" );
	                  
	Lmopros2lib() {
		HMODULE module = LoadLibrary( "lmopros2.dll" );
		if( module == NULL ) DIE( "   lmopros2.dll" );

		LOAD( CreateOpros );
		LOAD( DestroyOpros );
		LOAD( IsServerConnected );
		LOAD( RegisterChannel );
		LOAD( RegisterValueByID );
		LOAD( RegisterAttribute );
		LOAD( ReceiveControl );
	};
};

static Lmopros2lib library;

// -------------------------------------------------------------------------------------------------------
bool CreateOpros( 
		char *Addr, 
		int Port, 
		int TimeOut, 
		char *Name, 
		char *Password, 
		bool bSetTime, 
		bool bDebugOutput, 
		char *LogFileName )
{
	bool res;
	res = (	
		( bool(*)( char*, int, int, char*, char*, bool, bool, char* ) )library.c_CreateOpros 
		  ) ( Addr, Port, TimeOut, Name, Password, bSetTime, bDebugOutput, LogFileName );
	return res;
}

// -------------------------------------------------------------------------------------------------------
bool DestroyOpros( void ) 
{
	return( ( bool(*)() )library.c_DestroyOpros )();
}

// -------------------------------------------------------------------------------------------------------
bool IsServerConnected( void )
{
	return( ( bool(*)() )library.c_IsServerConnected )();
}

// -------------------------------------------------------------------------------------------------------
bool RegisterChannel(
		char *ID,
		WORD Type,
		bool WriteEnable,
		bool SaveValue,
		char *Comments,
		char *Prefix,
		char *Unit,
		char *FormatString, 
		char *Description, 
		WORD Signification, 
		char *EUInfo2 )
{
	bool res;
	res = (
		( bool(*)( char*, WORD, bool, bool, char*, char*,char*, char*, char*, WORD, char* ) )library.c_RegisterChannel
		  )( ID, Type, WriteEnable, SaveValue, Comments, Prefix, Unit, FormatString, Description, Signification, EUInfo2 );
	return( res );
}

// -------------------------------------------------------------------------------------------------------
bool RegisterValueByID( char *ID, FILETIME *DT, WORD Quality, VARIANT Value ) 
{
	return(	( bool(*)( char*, FILETIME*, WORD, VARIANT ) )library.c_RegisterValueByID )( ID, DT, Quality, Value );
}

// -------------------------------------------------------------------------------------------------------
bool RegisterAttribute( char *ID, WORD AttrID, WORD Type, VARIANT Value) 
{
	return(	( bool(*)( char*, WORD, WORD, VARIANT ) )library.c_RegisterAttribute)( ID, AttrID, Type, Value );
}

// -------------------------------------------------------------------------------------------------------
bool ReceiveControl( char *ID, int id_len, int *number, FILETIME *date, int *quality, VARIANT *value ) 
{
	return(	( bool(*)( char*, int, int*, FILETIME*, int*, VARIANT* ) )library.c_ReceiveControl )( ID, id_len, number, date, quality, value );
}
