#include "lmopros2.h"

class Lmopros2lib{
public:
	FARPROC c_CreateOpros;
	FARPROC c_DestroyOpros;
	FARPROC c_IsServerConnected;
	FARPROC c_RegisterChannel;
	FARPROC c_RegisterValueByID;
	FARPROC c_RegisterAttribute;
	FARPROC c_ReceiveControl;

#define DIE(s) do{MessageBoxA(NULL,s,"",0);ExitProcess(1);}while(0)

#define LOAD(func) do{\
	if((c_##func=GetProcAddress(module,"_c_" #func))==NULL) \
		DIE("    " #func "  lmopros2.dll"); \
} while(0)

	Lmopros2lib(){
		HMODULE module=LoadLibrary("lmopros2.dll");
		if(module==NULL) DIE("   lmopros2.dll");

		LOAD(CreateOpros);
		LOAD(DestroyOpros);
		LOAD(IsServerConnected);
		LOAD(RegisterChannel);
		LOAD(RegisterValueByID);
		LOAD(RegisterAttribute);
		LOAD(ReceiveControl);

	};

};

static Lmopros2lib library;

bool CreateOpros(char *Addr,int Port,int TimeOut,char *Name,char *Password,bool bSetTime,bool bDebugOutput,char *LogFileName){
	return
		(
			( bool(*)(char *Addr,int Port,int TimeOut,char *Name,char *Password,bool bSetTime,bool bDebugOutput,char *LogFileName) )
			library.c_CreateOpros
		)(Addr,Port,TimeOut,Name,Password,bSetTime,bDebugOutput,LogFileName);
}
bool DestroyOpros(void){
	return
		(
			( bool(*)() )
			library.c_DestroyOpros
		)();
}
bool IsServerConnected(void){
	return
		(
			( bool(*)() )
			library.c_IsServerConnected
		)();
}
bool RegisterChannel(char *ID,WORD Type,bool WriteEnable,bool SaveValue,char *Comments,char *Prefix,char *Unit,char *FormatString,char *Description,WORD Signification,char *EUInfo2){
	return
		(
			( bool(*)(char *ID,WORD Type,bool WriteEnable,bool SaveValue,char *Comments,char *Prefix,char *Unit,char *FormatString,char *Description,WORD Signification,char *EUInfo2) )
			library.c_RegisterChannel
		)(ID,Type,WriteEnable,SaveValue,Comments,Prefix,Unit,FormatString,Description,Signification,EUInfo2);
}
bool RegisterValueByID(char *ID,FILETIME *DT,WORD Quality,VARIANT Value){
	return
		(
			( bool(*)(char *ID,FILETIME *DT,WORD Quality,VARIANT Value) )
			library.c_RegisterValueByID
		)(ID,DT,Quality,Value);
}
bool RegisterAttribute(char *ID,WORD AttrID,WORD Type,VARIANT Value){
	return
		(
			( bool(*)(char *ID,WORD AttrID,WORD Type,VARIANT Value) )
			library.c_RegisterAttribute
		)(ID,AttrID,Type,Value);
}
bool ReceiveControl(char *ID,int id_len,DWORD *number,FILETIME *date,WORD *quality,VARIANT *value){
	return
		(
			( bool(*)(char *ID,int id_len,DWORD *number,FILETIME *date,WORD *quality,VARIANT *value) )
			library.c_ReceiveControl
		)(ID,id_len,number,date,quality,value);
}
