#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <windows.h>

#include "lmopros2.h"
#include "comutil.h"

// COM stub for _variant_t
void __stdcall _com_issue_error(long){}

#define DIE(...) do{\
	fprintf(stderr,__VA_ARGS__); \
	fprintf(stderr,"\n"); \
	exit(1); \
}while(0)

int random(int top){return(int)(1.0*top*rand()/(RAND_MAX+1));}

void exiting(){
	DestroyOpros();
}

static char *qualities[]={
	"OK",
	"Vyklyuchen",
	"Sostoyanie ne opredeleno",
	"Neispraven datchik",
	"Neispraven kontroller",
	"Znachenie nedostoverno",
	"Datchik ne podklyuchen",
	"Net svyazi",
	"Neispraven registrator",
};

char *variantstr(char *s,int s_len,VARIANT *v){
	switch(v->vt){
	case VT_BOOL: 
		sprintf(s,"%s",v->boolVal?"true":"false");
		break;
	case VT_UI1: 
		sprintf(s,"%d",(int)v->bVal);
		break;
	case VT_I4: 
		sprintf(s,"%d",v->lVal);
		break;
	case VT_R4: 
		sprintf(s,"%f",v->fltVal);
		break;
	case VT_R8: 
		sprintf(s,"%f",v->dblVal);
		break;
	default: 
		sprintf(s,"%s","unk");
	}
	
	s[s_len-1]='\0';
	return s;
}

int main(int argc,char **argv){
	char *host="localhost";
	int port=3000;
	char *username="opros1";
	char *password="";

	FILETIME t;
	_variant_t val;

	srand((unsigned int)time(NULL));

	if(argc>1) host=argv[1];
	if(argc>2) sscanf(argv[2],"%d",&port);
	if(argc>3) username=argv[3];
	if(argc>4) password=argv[4];

	//     LanMon
	if(! CreateOpros(host,port,10,username,password,false,true,"D:\\WORK\\lmopros2msvcssample\\Debug\\log.txt"))
		DIE("Could not starting connection thread to %s:%d as user %s with password '%s'",host,port,username,password);
	else
		printf("Starting connection thread to server LanMon at %s:%d as user %s\n",host,port,username);

	//       
	//      :     
	Sleep(2000);
	if( !IsServerConnected() )
		DIE("Could not connect to %s:%d as user %s with password '%s'",host,port,username,password);
	else
		printf("Connected to %s:%d as user %s\n",host,port,username);

	atexit(exiting);

	GetSystemTimeAsFileTime(&t);

	if(!RegisterChannel(
		"Mode",
		VT_BOOL,
        false, //    () ?
        false, //        ?
        "   " // Comments
	)) printf("Could not add channel 'Mode'\n"); 

	if(!RegisterValueByID(
		"Mode",
		&t,
		0,
		val=false
	)) printf("Could not change value for channel 'Mode'\n"); 

	if(!RegisterChannel(
		"Pump",
		VT_UI1,
        true,  //    () ?
        false, //        ?
        " ", // Comments
        "", // Prefix
        "", // Unit
        "", // FormatString
        "", // Description
        0, // Signification
        "\t" // EUInfo2
	)) printf("Could not add channel 'Pump'\n");

	if(!RegisterValueByID("Pump", &t, 0, val=0) )
		printf("Could not change value for channel 'Pump'\n"); 

	if(!RegisterChannel(
		"Pressure",
		VT_R8,
		true,
		false,
        "  ", // Comments
        "", // Prefix
        "", // Unit
        "%.2f" // FormatString
	)) printf("Could not add channel 'Pressure'\n");

	if(!RegisterValueByID("Pressure", &t, 0, val=0) )
		printf("Could not change value for channel 'Pressure'\n"); 

	if(!RegisterChannel(
		"TestNeisprav",
		VT_I4,
		false,
		false,
        " " // Comments
	)) printf("Could not add channel 'TestNeisprav'\n");

	if(!RegisterValueByID("TestNeisprav", &t, 0, val=0) )
		printf("Could not change value for channel 'TestNeisprav'\n"); 


	bool mode=false;
	bool pump=false;
	int neisprav=0;

	int index=0;
	for(int index=0;;Sleep(100),index++){
		char id[0x100];
		DWORD num;
		WORD quality;

		if(ReceiveControl(id,sizeof(id),&num,&t,&quality,&val)){
			char s[0x20];

			printf("%s: control message: value=%s, quality=%d\n",id,variantstr(s,sizeof(s),&val),quality);
		}

		if(index%10==0){
			GetSystemTimeAsFileTime(&t);

			int action=random(4);

			switch(action){
			case 0:
				val=mode=!mode;
				if(! RegisterValueByID("Mode",&t,0,val))
					printf("Mode: could not change value\n");
				else
					printf("Mode: value set to %s\n",val.boolVal?"true":"false");
				break;

			case 1:
				val=pump=!pump;
				if(! RegisterValueByID("Pump",&t,0,val))
					printf("Pump: could not change value\n");
				else
					printf("Pump: value set to %s\n",val.boolVal?"true":"false");
				break;

			case 2:
				val=0.5+1.0*rand()/RAND_MAX;
				if(!RegisterValueByID("Pressure", &t, 0, val) )
					printf("Pressure: could not change value\n");
				else
					printf("Pressure: value set to %.2f\n",val.dblVal);
				break;

			case 3:
				int v=random(9);
				if(!RegisterValueByID("TestNeisprav", &t, v, val=neisprav++) )
					printf("TestNeisprav: could not change value\n"); 
				else
					printf("TestNeisprav: value set to %d (%s)\n",v,qualities[v]);
				break;
			}
		}
	}

}

