//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "interface.h"
#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  CreateOpros(AddrEdit->Text, StrToInt(PortEdit->Text), 10, LoginEdit->Text, PassEdit->Text,
    false, true, ExtractFilePath(Application->ExeName) + "protokol.txt");
  CreateChannels(); //   
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  DestroyOpros();
}
//---------------------------------------------------------------------------
//      
void __fastcall TForm1::CfgChange(TObject *Sender)
{
  DestroyOpros();
  CreateOpros(AddrEdit->Text, StrToInt(PortEdit->Text), 10, LoginEdit->Text, PassEdit->Text,
    false, true, ExtractFilePath(Application->ExeName) + "protokol.txt");
  CreateChannels(); //    
}
//---------------------------------------------------------------------------
//   
void __fastcall TForm1::CreateChannels(void)
{
  TDateTime t = Now();

  if( ! RegisterChannel("Mode", VT_BOOL,
        false, //    () ?
        false, //        ?
        "   ") // Comments
    )
    ShowMessage("  !");
  if( ! RegisterValueByID("Mode", t, 0, (bool)ModeRG->ItemIndex) )
    ShowMessage("  !");

  if( ! RegisterChannel("Pump", VT_UI1,
        true,  //    () ?
        false, //        ?
        " ", // Comments
        "", // Prefix
        "", // Unit
        "", // FormatString
        "", // Description
        0, // Signification
        "\t" // EUInfo2
        )
    )
    ShowMessage("  !");
  if( ! RegisterValueByID("Pump", t, 0, PumpRG->ItemIndex) )
    ShowMessage("  !");

  if( ! RegisterChannel("Pressure", VT_R8, false, false,
        "  ", // Comments
        "", // Prefix
        "", // Unit
        "%.2f" // FormatString
        )
    )
    ShowMessage("  !");
  if( ! RegisterValueByID("Pressure", t, 0, StrToFloat(PEdit->Text)) )
    ShowMessage("  !");

  if( ! RegisterChannel("TestNeisprav", VT_I4, false, false,
        " " // Comments
        )
    )
    ShowMessage("  !");
  if( ! RegisterValueByID("TestNeisprav", t, TestNeispravCB->ItemIndex, 0) )
    ShowMessage("  !");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TimerTimer(TObject *Sender)
{
  StatusEdit->Text = IsServerConnected() ? "" : "!";

  ControlRequest * p = ReceiveControl();
  if( p )
  {
    ListBox1->Items->Add(p->id + " q=" + IntToStr(p->quality) + " v=" + p->value + " t=" + p->dt.DateTimeString());
    if( p->id == "Pump" )
      PumpRG->ItemIndex = (int)p->value;
    delete p;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ModeRGClick(TObject *Sender)
{
  if( ! RegisterValueByID("Mode", Now(), 0, (bool)ModeRG->ItemIndex) )
    ShowMessage("  !");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PumpRGClick(TObject *Sender)
{
  if( ! RegisterValueByID("Pump", Now(), 0, PumpRG->ItemIndex) )
    ShowMessage("  !");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PEditChange(TObject *Sender)
{
  if( ! RegisterValueByID("Pressure", Now(), 0, StrToFloat(PEdit->Text)) )
    ShowMessage("  !");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TestNeispravCBChange(TObject *Sender)
{
  if( ! RegisterValueByID("TestNeisprav", Now(), TestNeispravCB->ItemIndex, 0) )
    ShowMessage("  !");
}
//---------------------------------------------------------------------------

